#include<iostream.h>
#include<math.h>
#include<dpmi.h>
#include<time.h>

double s[256];
double c[256];
int q [8][3]=
{
{-30,-30,-30}, {-30,-30,30}, {-30,30,-30}, {-30,30,30},
{30,-30,-30},  {30,-30,30},  {30,30,-30},  {30,30,30},
};
int p [8][3]=q;

int ar [12][2]=
{
  {0,1},{0,2},{0,4},{3,1},{3,2},{3,7},{5,1},{5,4},{5,7},{6,2},{6,4},{6,7},
};

void inter(int ,int,int,int,int);// num, ax,bx,cx,dx
void project(int,int,int);
void init_cos_sin();
void transform();
void transform(int,int,int,int,int,int,int,int,int,int,int);
//2(sommets a modif) 3(coord joueur) 3(rotations) 3(translations);
void waitretrace();
extern vgasegment();
extern putpixel(int,int,int);
void line(int,int,int,int,int);

void main()
{
init_cos_sin();
vgasegment();
inter(0x10,0x13,0,0,0); //vga     //svga 640*480*256 -> ax=4f02h bx=100h
int key;
double h=1;
int x0,y0,z0;
x0=y0=z0=1;
int x,y,z;
x=y=z=1;
int rx,ry,rz;
rx=ry=rz=128;//initiazlisation
do
{
waitretrace();
project(0,12,0);
q=p;                             // svg des sommets
transform(0,7,x0,y0,z0,rx,ry,rz,x,y,z);
project(0,12,14);
getch();
key=inp(0x60);
switch (key)
{
case 72 : z-=4;   //avant
         break;
case 80 : z+=4;   //arriere
         break;
case 77 : ry+=4;  //droite
         break;
case 75 : ry-=4;  //gauche
         break;
//case 78 : h+=0.1;
//         break;
//case 74 : h-=0.1;
//         break;
//case 71 : rx+=4;
//         break;
case 73 : rx-=1; //haut
         break;
case 81 : rx+=1; //bas
         break;
}
if (rx>148) rx=148;
if (rx<108) rx=108;
ry=ry%256;
if (z<-250) z=-250;
}
while (key!=1);
inter(0x10,3,0,0,0);            // mode txt
}

void init_cos_sin()
{
cout<<endl<<"* INITIALISATION DES TABLES DE SINUS - COSINUS \n";
double A=PI;
int i;
for (i=0;i!=256;i++)
  {
    s[i]=sin(A);
    c[i]=cos(A);
    A+=PI/128;
    if (i%4==0) cout<<".";
   }
cout<<endl;
}

void transform(int ar1,int ar2,int x0,int y0,int z0,int ax,int ay,int az,int tx,int  ty,int tz)
{  //h=homotetie(taille)
double m[4][4];
//cout<<c[0]<<" "<<s[0]<<endl;;
m[0][3]=0;
m[1][3]=0;
m[2][3]=0;
m[3][3]=1;

m[0][0]=c[ay]*c[az];                        // 1
m[0][1]=c[ay]*s[az];                        // 0
m[0][2]=-(s[ay])   ;                        // 0
m[1][0]=(s[ax]*s[ay]*c[az] - c[ax]*s[az]);  // 0
m[1][1]=(s[ax]*s[ay]*s[az] + c[ax]*c[az]);  // 1
m[1][2]=s[ax]*c[ay];                       // 0
m[2][0]=(c[ax]*s[ay]*c[az] + s[ax]*s[az]);  // 0
m[2][1]=(c[ax]*s[ay]*s[az] - s[ax]*c[az]);  //-1
m[2][2]=c[ax]*c[ay];                        // 1
m[3][0]=tx;                                 // 0
m[3][1]=ty;                                 // 0
m[3][2]=tz;                                 // 0
//  fin de la matrice de transformation : translation/rotation/homotetie
int i;
double t0,t1,t2;
for (i=ar1;i<=ar2;i++)
  { //
  //cout<<q[i][0]<<" "<<q[i][1]<<" "<<q[i][2]<<endl;
              // 0                0               0
  t0=m[0][0]*q[i][0]+m[1][0]*q[i][1]+m[2][0]*q[i][2]+m[3][0];
  t1=m[0][1]*q[i][0]+m[1][1]*q[i][1]+m[2][1]*q[i][2]+m[3][1];
  t2=m[0][2]*q[i][0]+m[1][2]*q[i][1]+m[2][2]*q[i][2]+m[3][2];
  q[i][0]=t0;
  q[i][1]=t1;
  q[i][2]=t2;

   //cout<<q[i][0]<<" "<<q[i][1]<<" "<<q[i][2]<<endl;
   }
//cout<<endl;
}

void project(int ar1,int ar2,int col)
{
int x,y,i;
for (i=ar1;i!=ar2;i++)
 {
double x1,x2,y1,y2,z1=1,z2=1;
 //cout<<q[(ar[i][0])][0]<<" "<<q[ar[i][0]][1]<<" "<<q[ar[i][1]][0]<<" "<<q[ar[i][1]][1]<<endl;
  // viration obligatoire
  z1=(250.0/(300+q[ar[i][0]][2]));   //point de fuite
  z2=(250.0/(300+q[ar[i][1]][2]));
  //if (z1==0) z1=1;
  //if (z2==0) z2=1;
  //cout<<z1<<endl;
  x1=(z1*q[ar[i][0]][0]);
  y1=(z1*q[ar[i][0]][1]);
  x2=(z2*q[ar[i][1]][0]);
  y2=(z2*q[ar[i][1]][1]);
  line(160+x1,100+y1,160+x2,100+y2,col);

 }
}

void inter(int num, int ax, int bx, int cx, int dx)
{
__dpmi_regs r;     // interuption 32 bits
r.x.ax=ax;
r.x.bx=bx;
r.x.cx=cx;
r.x.dx=dx;
__dpmi_int(num,&r);
}



void waitretrace()
{
while (!(inp(0x3da) & 0x08));
}


void line(int x1,int y1, int x2,int y2, int couleur)

{
  int x,y;
  int Dx,Dy;
  int xincr,yincr;
  int erreur;
  int i;
  Dx = abs(x2-x1);
  Dy = abs(y2-y1);
  if(x1<x2)
    xincr = 1;
  else
    xincr = -1;
  if(y1<y2)
    yincr = 1;
  else
    yincr = -1;
  x = x1;
  y = y1;
  if(Dx>Dy)
    {
      erreur = Dx;
      for(i=0;i<Dx;i++)
	{
	  x += xincr;
	  erreur += Dy;
	  if(erreur>Dx)
	    {
	      erreur -= Dx;
	      y += yincr;
	    }
	  putpixel(x,y,couleur);
	}
    }
  else
    {
      erreur = Dy ;
      for(i=0;i<Dy;i++)
	{
	  y += yincr;
	  erreur += Dx;
	  if(erreur>Dy)
	    {
	      erreur -= Dy;
	      x += xincr;
	    }
	  putpixel(x,y,couleur);
	}
    }
}




